#ifndef UTIL_H
#define UTIL_H

// The Frequency is taken from http://www.phy.mtu.edu/~suits/notefreqs.html  
#define C0  16
#define D0  18
#define E0  20
#define F0  21
#define G0  24
#define A0	27
#define B0	30

#define C1  32
#define D1  36
#define E1  41
#define F1  43
#define G1  49
#define A1	55
#define B1	61

#define C2  65
#define D2  73
#define E2  82
#define F2  87
#define G2  98       
#define A2  110
#define B2  123

#define C3  130
#define D3  146
#define E3  164
#define F3  174
#define G3  196
#define A3	220
#define B3	246

#define C4  261
#define D4  293
#define E4  329
#define F4  349
#define G4  392
#define A4	440
#define B4	493

#define C5  523
#define D5  587
#define E5  659
#define F5  698
#define G5  784
#define A5	880
#define B5	987

#define C6  1047
#define D6  1175
#define E6  1319
#define F6  1397
#define G6  1568
#define A6	1760
#define B6	1976

#define C7  2093
#define D7  2349
#define E7  2637
#define F7  2794
#define G7  3136
#define A7	3520
#define B7	3951

#define C8  4186
#define D8  4699
#define E8  5274
#define F8  5588
#define G8  6272
#define A8	7040
#define B8	7902

// #define C6  661
// #define D6  588
// #define E6  524
// #define F6  495
// #define G6  441
// #define A6  393
// #define B6  350

// #define C7  330

#define PAUSE 80

#define pause1 200
#define pause2 500
#define pause3 1000
#define pause4 1500
#define pause5 5000

// Running configuration
unsigned int sounds[8][8];

// Other configurations
unsigned int configuration1[8][8] =
	{{C0, D0, E0, F0, G0, A0, B0, C1},
	 {D1, E1, F1, G1, A1, B1, C2, D2},
	 {E2, F2, G2, A2, B2, C3, D3, E3},
	 {F3, G3, A3, B3, C4, D4, E4, F4},
	 {G4, A4, B4, C5, D5, E5, F5, G5},
	 {C6, D6, E6, F6, G6, A6, B6, C7},
	 {D7, E7, F7, G7, A7, B7, C8, D8},
	 {E8, F8, G8, A8, B8, C0, D0, E0}};
unsigned int configuration2[8][8] =
	{{C6, D6, E6, F6, G6, A6, B6, C7},
	 {A4, B7, E5, D1, A0, F0, B3, G0},
	 {C3, D8, A8, B5, A2, A1, B3, F7},
	 {A8, G2, B8, C7, A8, A0, G2, A8},
	 {D7, C7, C0, F1, A0, D7, C0, B8},
	 {G2, C0, F1, D7, G2, C7, A0, F1},
	 {C7, A8, B8, F1, C0, B8, F1, C7},
	 {B8, D7, G2, C7, A8, C0, G2, D7}};
unsigned int configuration3[8][8] =
	{{B3, B1, C0, G8, D4, A6, B0, E3},
	 {G7, E7, B5, F3, E5, B8, C7, F7},
	 {B2, C3, G6, E4, D5, A7, C1, C8},
	 {A1, A4, G4, F1, E2, G5, E1, D7},
	 {C2, A0, F2, D3, A2, C4, C6, E0},
	 {F6, D1, A3, F5, D0, G2, B4, G1},
	 {E8, D2, D6, B6, E6, D8, F4, F8},
	 {A5, G0, F0, C5, A8, G3, B7, A0}};
unsigned int configuration4[8][8] =
	{{A3, D1, C4, E5, C3, A1, G7, F3},
	 {B5, B3, F6, B2, G2, F8, C6, A6},
	 {E7, C0, A1, G7, F7, B7, D4, E1},
	 {C5, G6, G3, D4, A8, D0, C0, B2},
	 {F3, F4, E2, C1, B3, C5, E5, A8},
	 {G3, D3, C7, A4, E1, A8, C6, F8},
	 {A1, B8, A2, B4, B0, B7, E5, A3},
	 {E0, C6, D0, F3, A1, G7, B1, D6}};
unsigned int configuration5[8][8] =
	{{D2, C1, F3, B0, C8, F7, F6, D3},
	 {E2, E3, A1, A0, F5, G5, E8, G6},
	 {G3, F4, A2, E5, C2, E7, B6, D5},
	 {F0, G0, C6, A0, E4, G2, G8, C4},
	 {G1, B4, B2, A7, E0, B8, B7, D4},
	 {F2, C7, G7, D8, B3, A5, C5, G4},
	 {B1, A8, D6, A4, F8, D1, A6, C3},
	 {A3, F1, E6, B5, D7, E1, C0, D0}};
unsigned int configuration6[8][8] =
	{{G6, B3, F2, F1, B5, D1, C3, A8},
	 {A2, E3, E2, G3, G2, B7, B4, F4},
	 {G1, F3, E5, E8, A0, A6, F8, G0},
	 {D3, G4, E0, A7, A3, D7, E1, C1},
	 {D5, E7, F7, E4, E6, D4, G7, B0},
	 {C8, C4, B2, B8, G5, A0, B1, F5},
	 {C6, G8, F0, C2, D2, C0, C7, D6},
	 {D8, D0, A4, B6, C5, A1, F6, A5}};


uint16_t adc_value;

int temp_result;
unsigned char pressed;
unsigned char pressed_array[]={0,0,0,0,0,0,0,0,0,0,0,0};
unsigned char keypad[8][8]={{ 1, 2, 3, 4, 5, 6, 7, 8},
		                    { 9,10,11,12,13,14,15,16},
							{17,18,19,20,21,22,23,24},
							{25,26,27,28,29,30,31,32},
							{33,34,35,36,37,38,39,40},
							{41,42,43,44,45,46,47,48},
							{49,50,51,52,53,54,55,56},
							{57,58,59,60,61,62,63,64}};

#endif // SD_H